% Name:     Michael Mayrhofer-R.
% Datum:    26.10.2009
%
% Beschreibung:
% Programm, um Farbbild mithilfe der Farbwerte zufaellig gewaehlter Pixel 
% in der Mitte bzw. vom ganzen Bild darauf zu pruefen, ob es sich um ein 
% Portrait handelt / bzw. ob sich in der Mitte des Bildes ein Gesicht
% befindet.
%
% Eingabe:
% Bild - Datei (*.png) in Farbe (RGB)
%
% Ausgabe:
% Variable: face = true, false
%
% Status:   beim Abschluss
%           Probleme mit:  foto_18, foto_19

% --------------------------------------------------------
% Initialisierungen:

% Zu ueberpruefendes Bild:
[bild, cmap] = imread('./Testbilder/foto_03.png');
figure
image(bild);
% Output-Variable, die angibt, ob es sich um ein Gesicht handelt.
face = false;

% Wieviele Testpixel in der Mitte bzw. vom ganzen Bild genommen werden:
N_testpixel_mitte = 1000;
N_testpixel = 1000;

% Ermitteln der Bildabmessungen:
bild_groesse = size(bild);
bild_hoehe = bild_groesse(1);
bild_breite = bild_groesse(2);

% Matrizen fuer gewaehlte Pixel:
testpixel_mitte = zeros(N_testpixel_mitte,2);
testpixel =  zeros(N_testpixel,2);

% --------------------------------------------------------
% Berechnungen:
% Zufaellige Bildpixel in der Mitte des Bildes / wo Gesicht vermutet wird:
testpixel_mitte(:,1) = ceil(bild_hoehe./2+(rand(N_testpixel_mitte, 1)-0.5).*bild_hoehe./3);
testpixel_mitte(:,2) = ceil(bild_breite./2+(rand(N_testpixel_mitte, 1)-0.5).*bild_breite./2);
% daraus Indizes generieren:
testpixel_mitte_rot_ind = sub2ind(bild_groesse,testpixel_mitte(:,1),testpixel_mitte(:,2),ones(N_testpixel_mitte,1).*1);
testpixel_mitte_gruen_ind = sub2ind(bild_groesse,testpixel_mitte(:,1),testpixel_mitte(:,2),ones(N_testpixel_mitte,1).*2);
testpixel_mitte_blau_ind = sub2ind(bild_groesse,testpixel_mitte(:,1),testpixel_mitte(:,2),ones(N_testpixel_mitte,1).*3);

% Entscheidende Parameter mittels Mittelwert & Std.-Abweichung ermitteln:
r_index = std(bild(testpixel_mitte_rot_ind))./mean(bild(testpixel_mitte_rot_ind));
g_index = std(bild(testpixel_mitte_gruen_ind))./mean(bild(testpixel_mitte_gruen_ind));
b_index = std(bild(testpixel_mitte_blau_ind))./mean(bild(testpixel_mitte_blau_ind));

%abs((r_index-(r_index+g_index+b_index)./3).*100);

% Verknuepfung der Parameter zur Entscheidung:
if abs((r_index-(r_index+g_index+b_index)./3).*100)>1.55
    face = true;
    disp('Yes, it is a FACE!');
else
    disp('What the ??!');
end

% Zufaellige Bildpixel vom gesamten Bild:
testpixel(:,1) = ceil((rand(N_testpixel, 1)).*bild_hoehe);
testpixel(:,2) = ceil((rand(N_testpixel, 1)).*bild_breite);
% daraus Indizes generieren:
testpixel_rot_ind = sub2ind(bild_groesse,testpixel(:,1),testpixel(:,2),ones(N_testpixel,1).*1);
testpixel_gruen_ind = sub2ind(bild_groesse,testpixel(:,1),testpixel(:,2),ones(N_testpixel,1).*2);
testpixel_blau_ind = sub2ind(bild_groesse,testpixel(:,1),testpixel(:,2),ones(N_testpixel,1).*3);

%mean(bild(testpixel_mitte_rot_ind))
%mean(bild(testpixel_rot_ind))
%mean(bild(testpixel_mitte_gruen_ind))
%mean(bild(testpixel_gruen_ind))
%mean(bild(testpixel_mitte_blau_ind))
%mean(bild(testpixel_blau_ind))

% Unterschied der Mittelwerte zwischen Mitte und außen:
diff_rot = (mean(bild(testpixel_mitte_rot_ind)))-mean(bild(testpixel_rot_ind));
diff_gruen = (mean(bild(testpixel_mitte_gruen_ind)))-mean(bild(testpixel_gruen_ind));
diff_blau = (mean(bild(testpixel_mitte_blau_ind)))-mean(bild(testpixel_blau_ind));

%(diff_rot-abs(((diff_gruen)+(diff_blau))./2))./mean(bild(testpixel_mitte_rot_ind))

if (diff_rot-((abs(diff_gruen)+abs(diff_blau))./2))./mean(bild(testpixel_mitte_rot_ind))>0.065
   disp('DOCH!');
   face = true;
end

